def temp-table tt1 field f1 as int.
def var r as int.
def var ch1 as char.
def var ch2 as char.

def var hext as handle extent 10.

def var hf1 as char extent 10.
def var hf2 as char extent 10.

def var hp1 as char extent 10.
def var hp2 as char extent 10.

def var ht1 as char extent 10.
def var ht2 as char extent 10.

def var hb1 as char extent 10.
def var hb2 as char extent 10.

def var he as char extent 10.

form ch1 ch2 with down frame ff.

function show returns int(input c1 as char, input c2 as char).
   display c1 @ ch1 c2 @ ch2 with frame ff.
   down with frame ff.
end.

function saveHandle returns int(input who as int, input idx as int, input h as handle).
   if who = 1 then do:
      if r = 1 then do:
         hp1[idx] = string(h).
      end.
      else do:
         hp2[idx] = string(h).
      end.
   end.
   
   if who = 2 then do:
      if r = 1 then do:
         hf1[idx] = string(h).
      end.
      else do:
         hf2[idx] = string(h).
      end.
   end.

   if who = 3 then do:
      he[idx] = string(h).
   end.
   
   if who = 4 then do:
      if r = 1 then do:
         ht1[idx] = string(h).
      end.
      else do:
         ht2[idx] = string(h).
      end.
   end.
   
   if who = 5 then do:
      if r = 1 then do:
         hb1[idx] = string(h).
      end.
      else do:
         hb2[idx] = string(h).
      end.
   end.
end.

function checkHandle returns int(input idx as int, input how as log, input v as log).
   def var l as log.
   l = (hf1[idx] = hf2[idx]).
   if l <> how
      then message "Func Handles" string(idx) ":" hf1[idx] hf2[idx] "are" string(l) "and expected" string(how).

   l = (hp1[idx] = hp2[idx]).
   if l <> how
      then message "Proc Handles" string(idx) ":" hp1[idx] hp2[idx] "are" string(l) "and expected" string(how).

   l = (hf1[idx] = he[idx] or hp1[idx] = he[idx]).
   if l <> how
      then message "Ext Proc Handles" string(idx) ":" hf1[idx] hp2[idx] he[idx] "are" string(l) "and expected" string(how).

   l = (ht1[idx] = ht2[idx]).
   if l <> how
      then message "Trigger Handles" string(idx) ":" ht1[idx] ht2[idx] "are" string(l) "and expected" string(how).

   l = (hb1[idx] = hb2[idx]).
   if l <> how
      then message "Trigger Handles" string(idx) ":" hb1[idx] hb2[idx] "are" string(l) "and expected" string(how).
      
   l = valid-handle(handle(hf1[idx])).
   if v <> l
      then message "Handle hf1[" string(idx) "] is" string(l) "and expected is" string(v).

   l = valid-handle(handle(hf2[idx])).
   if v <> l
      then message "Handle hf2[" string(idx) "] is" string(l) "and expected is" string(v).

   l = valid-handle(handle(hp1[idx])).
   if v <> l
      then message "Handle hp1[" string(idx) "] is" string(l) "and expected is" string(v).

   l = valid-handle(handle(hp2[idx])).
   if v <> l
      then message "Handle hp2[" string(idx) "] is" string(l) "and expected is" string(v).

   l = valid-handle(handle(he[idx])).
   if yes <> l
      then message "Handle he[" string(idx) "] is" string(l) "and expected is" string(v).

   l = valid-handle(handle(ht1[idx])).
   if v <> l
      then message "Handle ht1[" string(idx) "] is" string(l) "and expected is" string(v).

   l = valid-handle(handle(ht2[idx])).
   if v <> l
      then message "Handle ht2[" string(idx) "] is" string(l) "and expected is" string(v).

   l = valid-handle(handle(hb1[idx])).
   if v <> l
      then message "Handle hb1[" string(idx) "] is" string(l) "and expected is" string(v).

   l = valid-handle(handle(hb2[idx])).
   if v <> l
      then message "Handle hb2[" string(idx) "] is" string(l) "and expected is" string(v).

end.

procedure proc0.
   open query q0 for each tt1.
   show("1-q0", string(query q0:handle)).
   saveHandle(1, 1, query q0:handle).

   define query q1 for tt1.
   show("1-q1", string(query q1:handle)).
   saveHandle(1, 2, query q1:handle).

   form "ch" with frame f1.
   show("1-f1", string(frame f1:handle)).
   saveHandle(1, 3, frame f1:handle).
   
   find first book.
   show("1-book", string(buffer book:handle)).
   saveHandle(1, 4, buffer book:handle).

   define buffer bb for book.
   show("1-bb", string(buffer bb:handle)).
   saveHandle(1, 5, buffer bb:handle).

   define buffer tt for tt1.
   show("1-tt", string(buffer tt:handle)).
   saveHandle(1, 6, buffer tt:handle).

   show("1-tt1", string(buffer tt1:handle)).
   saveHandle(1, 7, buffer tt1:handle).

   define frame f2.
   show("1-f2", string(frame f2:handle)).
   saveHandle(1, 8, frame f2:handle).
end.

function func0 returns int.
   open query q0 for each tt1.
   show("2-q", string(query q0:handle)).
   saveHandle(2, 1, query q0:handle).

   define query q1 for tt1.
   show("2-q1", string(query q1:handle)).
   saveHandle(2, 2, query q1:handle).

   form "ch" with frame f1.
   show("2-f1", string(frame f1:handle)).
   saveHandle(2, 3, frame f1:handle).

   find first book.
   show("2-book", string(buffer book:handle)).
   saveHandle(2, 4, buffer book:handle).

   define buffer bb for book.
   show("2-bb", string(buffer bb:handle)).
   saveHandle(2, 5, buffer bb:handle).

   define buffer tt for tt1.
   show("2-tt", string(buffer tt:handle)).
   saveHandle(2, 6, buffer tt:handle).

   show("2-tt1", string(buffer tt1:handle)).
   saveHandle(2, 7, buffer tt1:handle).

   define frame f2.
   show("2-f2", string(frame f2:handle)).
   saveHandle(2, 8, frame f2:handle).
end.

on "1" anywhere do:
   open query q0 for each tt1.
   show("4-q", string(query q0:handle)).
   saveHandle(4, 1, query q0:handle).

   define query q1 for tt1.
   show("4-q1", string(query q1:handle)).
   saveHandle(4, 2, query q1:handle).

   form "ch" with frame f1.
   show("4-f1", string(frame f1:handle)).
   saveHandle(4, 3, frame f1:handle).

   find first book.
   show("4-book", string(buffer book:handle)).
   saveHandle(4, 4, buffer book:handle).

   define buffer bb for book.
   show("4-bb", string(buffer bb:handle)).
   saveHandle(4, 5, buffer bb:handle).

   define buffer tt for tt1.
   show("4-tt", string(buffer tt:handle)).
   saveHandle(4, 6, buffer tt:handle).

   show("4-tt1", string(buffer tt1:handle)).
   saveHandle(4, 7, buffer tt1:handle).

   define frame f2.
   show("4-f2", string(frame f2:handle)).
   saveHandle(4, 8, frame f2:handle).
end.

on find of person do:
   open query q0 for each tt1.
   show("5-q", string(query q0:handle)).
   saveHandle(5, 1, query q0:handle).

   define query q1 for tt1.
   show("5-q1", string(query q1:handle)).
   saveHandle(5, 2, query q1:handle).

   form "ch" with frame f1.
   show("5-f1", string(frame f1:handle)).
   saveHandle(5, 3, frame f1:handle).

   find first book.
   show("5-book", string(buffer book:handle)).
   saveHandle(5, 4, buffer book:handle).

   define buffer bb for book.
   show("5-bb", string(buffer bb:handle)).
   saveHandle(5, 5, buffer bb:handle).

   define buffer tt for tt1.
   show("5-tt", string(buffer tt:handle)).
   saveHandle(5, 6, buffer tt:handle).

   show("5-tt1", string(buffer tt1:handle)).
   saveHandle(5, 7, buffer tt1:handle).

   define frame f2.
   show("5-f2", string(frame f2:handle)).
   saveHandle(5, 8, frame f2:handle).
end.

r = 0.
run proc0.
func0().
apply "1" to current-window.
find first person.

r = 1.
run proc0.
func0().
apply "1" to current-window.
find first person.

open query q0 for each tt1.
show("3-q", string(query q0:handle)).
saveHandle(3, 1, query q0:handle).

define query q1 for tt1.
show("3-q1", string(query q1:handle)).
saveHandle(3, 2, query q1:handle).

form "ch" with frame f1.
show("3-f1", string(frame f1:handle)).
saveHandle(3, 3, frame f1:handle).

find first book.
show("3-book", string(buffer book:handle)).
saveHandle(3, 4, buffer book:handle).

define buffer bb for book.
show("3-bb", string(buffer bb:handle)).
saveHandle(3, 5, buffer bb:handle).

define buffer tt for tt1.
show("3-tt", string(buffer tt:handle)).
saveHandle(3, 6, buffer tt:handle).

show("3-tt1", string(buffer tt1:handle)).
saveHandle(3, 7, buffer tt1:handle).

define frame f2.
show("3-f2", string(frame f2:handle)).
saveHandle(3, 8, frame f2:handle).

checkHandle(1, no, no).
checkHandle(2, no, no).
checkHandle(3, no, no).
checkHandle(4, yes, yes).
checkHandle(5, no, no).
checkHandle(6, no, no).
checkHandle(7, yes, yes).
checkHandle(8, no, no).